SystemOrganization addCategory: #'ATSE-Reloj'!

Object subclass: #Manecilla
	instanceVariableNames: 'valor max min periodo next'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ATSE-Reloj'!

!Manecilla methodsFor: 'logic' stamp: 'juliohurtado 4/26/2012 04:02'!
avanzar
	"comment stating purpose of message"
	valor := valor+periodo.
	(valor >= max) ifTrue: [valor := min. 
		                             next isNil ifFalse: [next avanzar]].
	^ self! !

!Manecilla methodsFor: 'as yet unclassified' stamp: 'juliohurtado 4/26/2012 03:35'!
getTime
	"comment stating purpose of message"

	| temporary variable names |
	(next isNil) ifTrue: [^ valor asString] ifFalse:[^ (next getTime asString, ':' , valor asString)]! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:19'!
max

	^ max! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:19'!
max: anObject

	max := anObject! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:19'!
min

	^ min! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:19'!
min: anObject

	min := anObject! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:20'!
next

	^ next! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:20'!
next: anObject

	next := anObject! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:19'!
periodo

	^ periodo! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:19'!
periodo: anObject

	periodo := anObject! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:19'!
valor

	^ valor! !

!Manecilla methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 03:19'!
valor: anObject

	valor := anObject! !

Object subclass: #Reloj
	instanceVariableNames: 'menor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ATSE-Reloj'!

!Reloj methodsFor: 'logic' stamp: 'juliohurtado 4/26/2012 04:07'!
avanzar
	"comment stating purpose of message"
	menor isNil ifFalse:[menor avanzar].
	^self
	! !

!Reloj methodsFor: 'logic' stamp: 'juliohurtado 4/26/2012 04:19'!
correr
	"comment stating purpose of message"
	(1 to: 10) do: [menor avanzar.
		              Transcript show: self getHoraReloj; cr].
	^self
	! !

!Reloj methodsFor: 'logic' stamp: 'juliohurtado 4/26/2012 04:34'!
correr: veces
	"comment stating purpose of message"
	| i |
	i := 1.
      [i <= veces] whileTrue: [self menor avanzar.
		                     Transcript show: self getHoraReloj; cr.
		                      i:= i+1].
	^self
	! !

!Reloj methodsFor: 'logic' stamp: 'juliohurtado 4/26/2012 04:09'!
getHoraReloj
	"comment stating purpose of message"

	menor isNil ifFalse: [ ^ menor getTime].
	^ 'Vea la sombra del sol'
	! !

!Reloj methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 04:12'!
menor

	^ menor! !

!Reloj methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 04:12'!
menor: anObject

	menor := anObject! !

Observador subclass: #PanelReloj
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ATSE-Reloj'!

!PanelReloj methodsFor: 'as yet unclassified' stamp: 'juliohurtado 4/26/2012 04:51'!
upDate
	^ self! !

!PanelReloj methodsFor: 'as yet unclassified' stamp: 'juliohurtado 4/26/2012 22:40'!
upDate: anObject
      Transcript show: anObject getHoraReloj; cr.
	^ self! !

Observable subclass: #RelojObservable
	instanceVariableNames: 'menor'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'ATSE-Reloj'!

!RelojObservable methodsFor: 'logic' stamp: 'juliohurtado 4/26/2012 04:45'!
avanzar
	"comment stating purpose of message"
	menor isNil ifFalse:[menor avanzar].
	^self
	! !

!RelojObservable methodsFor: 'logic' stamp: 'juliohurtado 4/26/2012 04:45'!
correr
	"comment stating purpose of message"
	(1 to: 10) do: [menor avanzar.
		              Transcript show: self getHoraReloj; cr].
	^self
	! !

!RelojObservable methodsFor: 'logic' stamp: 'juliohurtado 4/26/2012 22:37'!
correr: veces
	"comment stating purpose of message"
	| i |
	i := 1.
      [i <= veces] whileTrue: [self avanzar.
		                               self notifyAll.
		                               i:= i+1].
	^self
	! !

!RelojObservable methodsFor: 'logic' stamp: 'juliohurtado 4/26/2012 04:45'!
getHoraReloj
	"comment stating purpose of message"

	menor isNil ifFalse: [ ^ menor getTime].
	^ 'Vea la sombra del sol'
	! !

!RelojObservable methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 04:45'!
menor

	^ menor! !

!RelojObservable methodsFor: 'accessing' stamp: 'juliohurtado 4/26/2012 04:45'!
menor: anObject

	menor := anObject! !
